import java.awt.*;
import javax.swing.*;
import jfd.ale.*;
import java.lang.reflect.Field;

public class AdvancedJFC2 extends JFrame implements FieldToComponentMapper
{
   private JLabel type         = null;
   private JLabel path         = null;
   private JComboBox typeCombo = null;
   private JComboBox pathCombo = null;
   private JPanel topPanel     = null;

   private JLabel brightness        = null;
   private JLabel contrast          = null;
   private JSlider brightnessSlider = null;
   private JSlider contrastSlider   = null;
   private JLabel brightnessValue   = null;
   private JLabel contrastValue     = null;
   private JButton centerButton     = null;
   private JPanel middlePanel       = null;

   private JLabel fiftyPercent      = null;
   private JLabel oneHundredPercent = null;
   private JLabel twoHundredPercent = null;
   private JLabel width             = null;
   private JLabel height            = null;
   private JSlider scalingSlider    = null;
   private JPanel bottomPanel       = null;

   private JLabel size              = null;
   private JLabel sizeValue         = null;
   private JButton b1               = null;
   private JButton b2               = null;
   private JButton b3               = null;
   private JButton b4               = null;
   private JPanel sizePanel         = null;

   private JButton previewButton    = null;
   private JButton zoomButton       = null;
   private JButton finalButton      = null;
   private JPanel buttonPanel       = null;

   private JButton scan             = null;
   private JLabel scanLabel         = null;
   private JPanel infoPanel         = null;
   private JPanel imagePanel        = null;
   private JLabel imageLabel1       = null;
   private JLabel imageLabel2       = null;
   private JLabel imageLabel3       = null;
   private JLabel imageLabel4       = null;

   public AdvancedJFC2() throws Exception
   {
      addWindowListener(new AppCloser());

      type = new JLabel("Type:");
      path = new JLabel("Path:");

      typeCombo = new JComboBox(
         new Object[]
         {
            "Sharp Millions of Colors",
            "Millions of Colors",
         }
      );

      typeCombo.setSelectedIndex(0);

      pathCombo = new JComboBox(
         new Object[]
         {
            "Screen",
            "Linotronic 300",
         }
      );

      pathCombo.setSelectedIndex(0);

      topPanel = new JPanel();
      topPanel.setBorder(BorderFactory.createEtchedBorder());

      ALE.brew(
         "advancedjfc2.ale", "topPanel", this, topPanel
      );


      brightness       = new JLabel("Brightness");
      contrast         = new JLabel("Contrast");
      brightnessSlider = new JSlider(SwingConstants.HORIZONTAL, 0, 250, 125);
      contrastSlider   = new JSlider(SwingConstants.HORIZONTAL, 0, 250, 125);

      centerButton     = new JButton(new ImageIcon(gifName("contrast")));
      centerButton.setBorder(BorderFactory.createBevelBorder(0));

      brightnessValue = new JLabel("125");
      contrastValue   = new JLabel("125");

      middlePanel = new JPanel();
      middlePanel.setBorder(BorderFactory.createEtchedBorder());

      ALE.brew(
         "advancedjfc2.ale", "middlePanel", this, middlePanel
      );

      fiftyPercent      = new JLabel("50  %");
      oneHundredPercent = new JLabel("Scaling:  100 %");
      twoHundredPercent = new JLabel("200 %");
      width             = new JLabel("Width:   8.49in");
      height            = new JLabel("Height:   14.00in");
      scalingSlider     = new JSlider(SwingConstants.HORIZONTAL, 50, 200, 100);

      bottomPanel = new JPanel();
      bottomPanel.setBorder(BorderFactory.createEtchedBorder());

      ALE.brew(
         "advancedjfc2.ale", "bottomPanel", this, bottomPanel
      );

      size = new JLabel("Size:");
      sizeValue = new JLabel("1956K");

      b1     = new JButton(new ImageIcon(gifName("reverse")));
      b1.setBorder(BorderFactory.createBevelBorder(0));
      b2     = new JButton(new ImageIcon(gifName("inverse")));
      b2.setBorder(BorderFactory.createBevelBorder(0));
      b3     = new JButton(new ImageIcon(gifName("balance")));
      b3.setBorder(BorderFactory.createBevelBorder(0));
      b4     = new JButton(new ImageIcon(gifName("lock")));
      b4.setBorder(BorderFactory.createBevelBorder(0));
      sizePanel = new JPanel();

      ALE.brew(
         "advancedjfc2.ale", "sizePanel", this, sizePanel
      );

      previewButton = new JButton("Preview");
      zoomButton = new JButton("Zoom");
      finalButton = new JButton("Final");
      buttonPanel = new JPanel();
      buttonPanel.setBorder(BorderFactory.createEtchedBorder());

      ALE.brew(
         "advancedjfc2.ale", "buttonPanel", this, buttonPanel
      );

      scan = new JButton(new ImageIcon(gifName("scan")));
      scan.setBorder(BorderFactory.createBevelBorder(0));
      scanLabel = new JLabel("4c/3c");

      imagePanel = new JPanel();

      imagePanel.setBorder(
         BorderFactory.createTitledBorder(
            BorderFactory.createEtchedBorder(),
            "Image is ..."
         )
      );

      infoPanel = new JPanel();

      infoPanel.setBorder(
         BorderFactory.createTitledBorder(
            BorderFactory.createBevelBorder(0),
            "Information"
         )
      );
   
      imageLabel1 = new JLabel("75 dpi");
      imageLabel2 = new JLabel("Millions of Colors");
      imageLabel3 = new JLabel("(16.7 million colors)");
      imageLabel4 = new JLabel("Normal Sharpening");

      ALE.brew(
         "advancedjfc2.ale", "imagePanel", this, imagePanel
      );

      ALE.brew(
         "advancedjfc2.ale", "infoPanel", this, infoPanel
      );

      ALE.brew(
         "advancedjfc2.ale", "main", this, getContentPane()
      );

      setSize(340, 550);
      setVisible(true);
   }

   private static String gifName(String name)
   {
      return(
         "gifs" + java.io.File.separator + "scan" +
         java.io.File.separator + name + ".gif"
      );
   }

   public Component mapToComponent(Field f)
      throws Exception
   {
      return((Component)f.get(this));
   }

   public static void main(String args[]) throws Exception
   {
      new AdvancedJFC2();
   }
}
