package jfd.ale;

import java.util.Hashtable;

abstract class ReferenceMethodVisitor extends MethodVisitor
{
   private String allowedSelfAttributes[] = null;

   private static final String FORMAT =
      "In section \"{0}\", attribute \"{1}\" of Component \"{2}\"\n" +
      "depends upon Component \"{3}\", attribute \"{4}\"\n"          +
      "\n"                                                           +
      "Components are sized and located in the following order:\n" +
      "   (1) All components' widths/heights are calculated\n" +
      "   (2) All components' locations are calculated\n"      +
      "\n"                                                     +
      "It is not allowed for any attribute of any component to depend\n" +
      "upon an attribute of another component whose value has not been\n" +
      "already calculated.";

   public ReferenceMethodVisitor(
      Hashtable table,
      String section,
      String name,
      String attribute,
      String allowedSelfAttributes[]
   )
   {
      super(table, section, name, attribute);

      this.allowedSelfAttributes = allowedSelfAttributes;
   }

   protected String getFormat()
   {
      return(FORMAT);
   }

   protected boolean isAllowedSelfAttribute(String selfAttribute)
   {
      for(int i = 0; i < allowedSelfAttributes.length; i ++)
         if(selfAttribute.equals(allowedSelfAttributes[i]))
            return(true);

      return(false);
   }
}
